### Wermer experiment, version 2


### Folder structure:

- `subjects` : contains the source code of the experiment subjects.
- `tests` : contains manual and automated tests (t3-daikon) to be used as comparison.
- `mutants` : contains the source code of the mutants of the subjects. Some mutants are generated (with Major); each such mutant injects an error (though it may turn out that the mutation is a non-error). Some mutants are manually crafted, these should all be non-error mutants, intended to check the wlp does indeed identify them as non-errors.

- `data` : contains raw data generated by the experiments.
- `tmp`  : contains temporary artifacts such as log files generated by the experiments.

- `t3daikongen` : contains a Java program and related classes to generate t3 test suites and daikon invariants.

### Scripts and script-related artifacts

- `WlpExperiment.hs` : a Haskell script to run the whole wlp-part of wermer experiments (only the wlp part!).
- `generateMutans.hs` : to generate the source of code bug-injecting mutants. It uses Major, but does not do any mutation testing. The experiment folder should already contain these generated mutants so there should be no need to call this script again.
- `mutation.mml` : the definition of the used mutation operators and targets. This is used by Major and `generateMutans.hs`.
- `mutation.mml.bin` : compiled version of `mutation.mml`.

